'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _FormField2 = require('./FormField');

var _FormField3 = _interopRequireDefault(_FormField2);

var _events = require('../utils/events');

var _events2 = _interopRequireDefault(_events);

var _Input = require('./Input');

var _Input2 = _interopRequireDefault(_Input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = (_temp2 = _class = function (_FormField) {
  _inherits(Select, _FormField);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isOpen: false,
      highlightedOptionIndex: null
    }, _this.handleInputClick = function (event) {
      event.stopPropagation();
      event.preventDefault();
      _this._getInputSkinPart().blur();
      _this.setState({
        isOpen: !_this.state.isOpen,
        highlightedOptionIndex: _this.getHighlightedOptionIndex()
      });
    }, _this.getSelectedOption = function () {
      var _this$props = _this.props,
          options = _this$props.options,
          value = _this$props.value,
          allowBlank = _this$props.allowBlank;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;

          if (option.value === value) return option;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!allowBlank) return options[0];
    }, _this.isSelectedOption = function (option) {
      return option.value === _this.props.value;
    }, _this.getHighlightedOptionIndex = function () {
      // If nothing is higlighted, highlight selected option
      // In case nothing is selected, highlight first option
      var _this$props2 = _this.props,
          options = _this$props2.options,
          isOpeningUpward = _this$props2.isOpeningUpward;

      var currentIndex = _this.state.highlightedOptionIndex;
      var index = 0;
      if (currentIndex !== null) {
        index = currentIndex;
      } else {
        var selectedOption = _this.getSelectedOption();
        if (selectedOption) {
          index = options.findIndex(function (option) {
            return option.value === selectedOption.value;
          });
        }
      }
      if (isOpeningUpward) {
        var reverseIndex = options.length - 1 - index;
        return reverseIndex;
      }
      return index;
    }, _this.setHighlightedOptionIndex = function (optionIndex) {
      if (!_this.isHighlightedOption(optionIndex) && _this.isDisabledOption(optionIndex)) {
        _this.setState({ highlightedOptionIndex: optionIndex });
      }
    }, _this.isHighlightedOption = function (optionIndex) {
      return _this.state.highlightedOptionIndex === optionIndex;
    }, _this.isDisabledOption = function (optionIndex) {
      var options = _this.props.options;

      var option = options[optionIndex];
      return option && !option.isDisabled;
    }, _this.focus = function () {
      return _this.state.isOpen ? _this.close() : _this.open();
    }, _this.open = function () {
      if (!_this.state.isOpen) {
        _this.setState({
          isOpen: true,
          highlightedOptionIndex: _this.getHighlightedOptionIndex()
        });
      }
    }, _this.close = function () {
      if (_this.state.isOpen) {
        _this.setState({
          isOpen: false,
          highlightedOptionIndex: null
        });
      }
    }, _this.handleClickOnOption = function (option, event) {
      if (option.isDisabled) return;
      if (_this.props.onBlur) _this.props.onBlur(event);
      if (_this.props.onChange) _this.props.onChange(option.value, event);
      _this.close();
    }, _this._handleDocumentClick = function (event) {
      var root = _this._getRootSkinPart();
      var isDescendant = _events2.default.targetIsDescendant(event, _reactDom2.default.findDOMNode(root));
      if (_this.state.isOpen && !isDescendant) {
        _this.setState({
          isOpen: false,
          highlightedOptionIndex: null
        });
      }
    }, _this._handleSelectionOnEnterKey = function (event) {
      var _this$props3 = _this.props,
          options = _this$props3.options,
          isOpeningUpward = _this$props3.isOpeningUpward;

      var currentIndex = _this.state.highlightedOptionIndex;
      var reverseIndex = options.length - 1 - currentIndex;
      var highlightedOption = options[isOpeningUpward ? reverseIndex : currentIndex];
      _this.handleClickOnOption(highlightedOption, event);
    }, _this._handleHighlightMove = function (currentIndex, direction) {
      var options = _this.props.options;

      var lowerIndexBound = 0;
      var upperIndexBound = options.length - 1;
      var newIndex = direction === 'up' ? currentIndex - 1 : currentIndex + 1;

      // Make sure new index is within options bounds
      newIndex = Math.max(lowerIndexBound, Math.min(newIndex, upperIndexBound));

      if (options[newIndex].isDisabled) {
        // Try to jump over disabled options
        var canMoveUp = newIndex > lowerIndexBound;
        var canMoveDown = newIndex < upperIndexBound;
        if (direction === 'up' && canMoveUp || direction === 'down' && canMoveDown) {
          _this._handleHighlightMove(newIndex, direction);
        }
      } else {
        _this.setHighlightedOptionIndex(newIndex);
      }
    }, _this._handleKeyDown = function (event) {
      var highlightOptionIndex = _this.state.highlightedOptionIndex;
      switch (event.keyCode) {
        case 13:
          // Select currently highlighted option on Enter key
          _this._handleSelectionOnEnterKey(event);
          break;
        case 27:
          // Close on Escape key
          _this.close();
          break;
        case 38:
          // Move selection higlight 'up' on Arrow Up key
          _this._handleHighlightMove(highlightOptionIndex, 'up');
          break;
        case 40:
          // Move selection higlight 'down' on Arrow Down key
          _this._handleHighlightMove(highlightOptionIndex, 'down');
          break;
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Select, [{
    key: 'componentWillUpdate',


    // ========= COMPONENT LIFE CYCLE =========

    value: function componentWillUpdate(nextProps, nextState) {
      if (!this.state.isOpen && nextState.isOpen) {
        _events2.default.addEventsToDocument(this._getDocumentEvents());
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevState.isOpen && !this.state.isOpen) {
        _events2.default.removeEventsFromDocument(this._getDocumentEvents());
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.state.isOpen) {
        _events2.default.removeEventsFromDocument(this._getDocumentEvents());
      }
    }
  }, {
    key: 'prepareSkinProps',
    value: function prepareSkinProps(props) {
      return Object.assign({}, _get(Select.prototype.__proto__ || Object.getPrototypeOf(Select.prototype), 'prepareSkinProps', this).call(this, props), {
        selectedOption: this.getSelectedOption(),
        isOpen: this.state.isOpen
      });
    }

    // ========= PUBLIC SKIN API =========

    // Focus the component - toggle dropdown


    // ========= PRIVATE HELPERS =========

  }, {
    key: '_getDocumentEvents',
    value: function _getDocumentEvents() {
      return {
        click: this._handleDocumentClick,
        touchend: this._handleDocumentClick,
        keydown: this._handleKeyDown
      };
    }
  }, {
    key: '_getRootSkinPart',
    value: function _getRootSkinPart() {
      return this.skinParts[Select.SKIN_PARTS.ROOT];
    }
  }, {
    key: '_getInputSkinPart',
    value: function _getInputSkinPart() {
      return this.skinParts[Select.SKIN_PARTS.INPUT];
    }
  }]);

  return Select;
}(_FormField3.default), _class.SKIN_PARTS = {
  ROOT: 'root',
  INPUT: _Input2.default.SKIN_PARTS.INPUT,
  OPTIONS: 'options'
}, _class.propTypes = Object.assign({}, _FormField3.default.propTypes, {
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.string.isRequired,
    isDisabled: _propTypes2.default.bool
  })).isRequired,
  optionRenderer: _propTypes2.default.func,
  value: _propTypes2.default.string,
  allowBlank: _propTypes2.default.bool,
  placeholder: _propTypes2.default.string,
  isOpeningUpward: _propTypes2.default.bool
}), _class.defaultProps = {
  allowBlank: true,
  isOpeningUpward: false
}, _temp2);
exports.default = Select;
//# sourceMappingURL=Select.js.map