'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactCssThemr = require('react-css-themr');

var _identifiers = require('./identifiers');

var _InputSkin = require('./InputSkin');

var _InputSkin2 = _interopRequireDefault(_InputSkin);

var _Select = require('../../components/Select');

var _Select2 = _interopRequireDefault(_Select);

var _SimpleSelect = require('../../themes/simple/SimpleSelect.scss');

var _SimpleSelect2 = _interopRequireDefault(_SimpleSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectSkin = function (_Component) {
  _inherits(SelectSkin, _Component);

  function SelectSkin() {
    _classCallCheck(this, SelectSkin);

    return _possibleConstructorReturn(this, (SelectSkin.__proto__ || Object.getPrototypeOf(SelectSkin)).apply(this, arguments));
  }

  _createClass(SelectSkin, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          component = _props.component,
          theme = _props.theme,
          className = _props.className,
          options = _props.options,
          optionRenderer = _props.optionRenderer,
          isOpen = _props.isOpen,
          placeholder = _props.placeholder,
          label = _props.label,
          error = _props.error,
          isOpeningUpward = _props.isOpeningUpward;

      var selectedOption = component.getSelectedOption();
      var inputValue = selectedOption ? selectedOption.label : '';
      var highlightedOptionIndex = component.getHighlightedOptionIndex();
      var isFirstOptionHighlighted = highlightedOptionIndex === 0;
      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)([className, theme.select, isOpen ? theme.isOpen : null, isOpeningUpward ? theme.openUpward : null]),
          ref: function ref(element) {
            return component.registerSkinPart(_Select2.default.SKIN_PARTS.ROOT, element);
          }
        },
        _react2.default.createElement(_InputSkin2.default, {
          className: theme.selectInput,
          label: label,
          value: inputValue,
          onClick: component.handleInputClick,
          component: component,
          placeholder: placeholder,
          error: error,
          readOnly: true
        }),
        _react2.default.createElement(
          'ul',
          {
            className: (0, _classnames2.default)([theme.options, isFirstOptionHighlighted ? theme.firstOptionHighlighted : null]),
            ref: function ref(element) {
              return component.registerSkinPart(_Select2.default.SKIN_PARTS.OPTIONS, element);
            } },
          (isOpeningUpward ? options.slice().reverse() : options).map(function (option, index) {
            return _react2.default.createElement(
              'li',
              {
                key: index,
                className: (0, _classnames2.default)([theme.option, component.isSelectedOption(option) ? theme.selectedOption : null, component.isHighlightedOption(index) ? theme.highlightedOption : null, option.isDisabled ? theme.disabledOption : null]),
                onClick: function onClick(event) {
                  return component.handleClickOnOption(option, event);
                },
                onMouseEnter: function onMouseEnter() {
                  return component.setHighlightedOptionIndex(index);
                }
              },
              optionRenderer ? optionRenderer(option) : option.label
            );
          })
        )
      );
    }
  }]);

  return SelectSkin;
}(_react.Component);

;

exports.default = (0, _reactCssThemr.themr)(_identifiers.SELECT, _SimpleSelect2.default, { withRef: true })(SelectSkin);
//# sourceMappingURL=SelectSkin.js.map