'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LabelProp = exports.pickDOMProps = undefined;

var _pickBy2 = require('lodash/pickBy');

var _pickBy3 = _interopRequireDefault(_pickBy2);

var _DOMProperty = require('react-dom/lib/DOMProperty');

var _DOMProperty2 = _interopRequireDefault(_DOMProperty);

var _EventPluginRegistry = require('react-dom/lib/EventPluginRegistry');

var _EventPluginRegistry2 = _interopRequireDefault(_EventPluginRegistry);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reactProps = {
  children: true,
  dangerouslySetInnerHTML: true,
  key: true,
  ref: true,
  autoFocus: true,
  defaultValue: true,
  defaultChecked: true,
  innerHTML: true,
  suppressContentEditableWarning: true,
  onFocusIn: true,
  onFocusOut: true
};

var pickDOMProps = exports.pickDOMProps = function pickDOMProps(props) {
  return (0, _pickBy3.default)(props, function (_, key) {
    return _DOMProperty2.default.properties.hasOwnProperty(key) || _DOMProperty2.default.isCustomAttribute(key) || reactProps.hasOwnProperty(key) && reactProps[key] || _EventPluginRegistry2.default.registrationNameModules.hasOwnProperty(key);
  });
};

var LabelProp = exports.LabelProp = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]);
//# sourceMappingURL=props.js.map